package com.ebelter.sdksdemo;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.view.WindowManager;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.ebelter.sdksdemo.utils_permission.PermissionHelper;
import com.ebelter.sdksdemo.utils_permission.per_interface.PermissionInterface;


public class ActivityPermission extends Activity implements PermissionInterface {

    private static final String TAG = "ActivityPermissionRequst";

    private LinearLayout ll_permission_groud;
    private TextView tv_permission_exit;
    private TextView tv_permission_setting;

    // 权限申请
    private PermissionHelper mPermissionHelper = new PermissionHelper(this, this);

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_permission_layout);

        initData();
    }

    protected void initData() {
        // 隐藏状态栏
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        //发起权限申请
        mPermissionHelper.requestPermissions();
    }


    // ========================================================= 权限部分 permission


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        mPermissionHelper.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (mPermissionHelper.requestPermissionsResult(requestCode, permissions, grantResults)) {
            //权限请求结果，并已经处理了该回调
            return;
        }
    }

    @Override
    public int getPermissionsRequestCode() {
        //设置权限请求requestCode，只有不跟onRequestPermissionsResult方法中的其他请求码冲突即可。
        return PermissionHelper.LOCATION_CODE;
    }

    @Override
    public String[] getPermissions() {
        //设置该界面所需的全部权限
        return new String[]{
                Manifest.permission.BLUETOOTH,
                Manifest.permission.ACCESS_FINE_LOCATION,
                Manifest.permission.ACCESS_COARSE_LOCATION,
                Manifest.permission.BLUETOOTH_ADMIN

        };
    }

    @Override
    public void requestPermissionsSuccess() {
        //权限请求用户已经全部允许
        startActivity(new Intent(this, MainActivity.class));
        finish();
    }

    @Override
    public void requestNoPermissionsFail() {
        finish();
    }

    @Override
    public void requestPermissionsFail() {
        //权限请求不被用户允许。可以提示并退出或者提示权限的用途并重新发起权限申请。
        finish();
    }
}
