package com.ebelter.sdksdemo;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import com.ebelter.sdks.utils.LogUtils;

@SuppressLint("Registered")
public class SDKBaseActivity extends Activity {


    String TAG = null;
    private static final String[] BLUETOOTH_PERMISSIONS = new String[]{
            Manifest.permission.BLUETOOTH,
            Manifest.permission.ACCESS_FINE_LOCATION,
            Manifest.permission.ACCESS_COARSE_LOCATION,
            Manifest.permission.BLUETOOTH_ADMIN
    };


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        TAG=getClass().getSimpleName();
        checkPermissions(0);
    }

    private void checkPermissions(int index) {
        if (index==-1){
            LogUtils.i(TAG, "---  index==-1  ---  所有权限授权完成");
            return;
        }
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {//android 6.0需要动态申请权限
            String permission = BLUETOOTH_PERMISSIONS[index];
            // 首先是判断 此权限是否开启
            if (ContextCompat.checkSelfPermission(this, permission) != PackageManager.PERMISSION_GRANTED) {
                //没有授权的情况下  去调用授权对话框
                ActivityCompat.requestPermissions(this, new String[]{permission}, 1);
            } else {
                int nextIndex = getNextPermissionIndex(BLUETOOTH_PERMISSIONS,permission);
                checkPermissions(nextIndex);
            }

        }
    }

    private int getNextPermissionIndex(String[] permissions,String p){
        int index = 0;
        for (int i = 0;i<permissions.length;i++){
            if (p.equals(permissions[i])){
                index=i;
                break;
            }
        }
        if (index<permissions.length-1){index++;}else {index=-1;}
        return index;
    }


    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);


        if (grantResults.length > 0) {
            String p = permissions[0];
            if (grantResults[0] == PackageManager.PERMISSION_DENIED) {
                // Permission Denied 权限被拒绝
                LogUtils.i(TAG,"----onRequestPermissionsResult--permissions2[0] = "+p+"--权限被拒绝");
                //检测是否选中 “不在询问” 被用户禁止
                if (!ActivityCompat.shouldShowRequestPermissionRationale(this, p)){
                    //ToastUtil.show(R.string.qkksyqx);//请打开所有权限
                    LogUtils.i(TAG,"----onRequestPermissionsResult--permissions2[0] = "+p+"--权限被拒绝-用户选择了不在询问");
                    //直接暴力跳转到权限设置界面
                    Intent intent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
                    Uri uri = Uri.fromParts("package", this.getPackageName(), null);
                    intent.setData(uri);
                    this.startActivityForResult(intent, 77);
                    return;
                }
            }
            int nextIndex = getNextPermissionIndex(permissions,p);
            checkPermissions(nextIndex);
        }
    }



}
