package com.ebelter.sdksdemo;

import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import com.ebelter.sdks.bases.BlueScan;
import com.ebelter.sdks.interfaces.IScanCallback;
import com.ebelter.sdks.utils.LogUtils;
import java.util.ArrayList;
import java.util.List;

public class SelectBlueActivity extends SDKBaseActivity {
    public static final String TAG = "SelectBlueActivity";


    public static final String ADDRESS = "ADDRESS";


    private ListView select_lv;
    private Button select_sure_bt;

    private BlueScan mBlueScan;
    BondAdapter mBondAdapter;
    List<BluetoothDevice> blueList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_select_blue);
        FV();
        initData();
    }

    private void initData() {
        blueList = new ArrayList<>();
        mBondAdapter = new BondAdapter();
        select_lv.setAdapter(mBondAdapter);

        mBlueScan = new BlueScan(this);

        mBlueScan.setScanCallback(new IScanCallback() {
            @Override
            public void beforeScan() {

            }

            @Override
            public void scanOneDevice(BluetoothDevice device, int rssi, byte[] scanRecord) {



                LogUtils.i(TAG, "--------扫描到--Name=" + device.getName() + "--Address=" + device.getAddress());
                String address = device.getAddress();
                boolean isC = false;//查询集合里面是否有此地址的蓝牙的设备
                for (int i = 0; i < blueList.size(); i++) {
                    if (TextUtils.equals(address, blueList.get(i).getAddress())) {
                        isC = true;
                        break;
                    }
                }
                if (!isC) {//没有的话就加入集合
                    if (blueList != null) blueList.add(device);
                    if (mBondAdapter != null) mBondAdapter.notifyDataSetChanged();
                }


            }

            @Override
            public void overScan() {
                if (mBlueScan != null) {
                    mBlueScan.startScanBluetoothDevices();
                }
            }
        });

        select_lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                mBondAdapter.checkAddress = blueList.get(position).getAddress();
                mBondAdapter.checkName = blueList.get(position).getName();
                mBondAdapter.notifyDataSetChanged();

            }
        });


        select_sure_bt.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent = new Intent();
                intent.putExtra(ADDRESS, mBondAdapter.checkAddress);
                setResult(101, intent);
                finish();
            }
        });

        mBlueScan.startScanBluetoothDevices();


    }

    private void FV() {
        select_lv = findViewById(R.id.select_lv);
        select_sure_bt = findViewById(R.id.select_sure_bt);
    }


    public class BondAdapter extends BaseAdapter {


        String checkAddress;
        String checkName;

        @Override
        public int getCount() {
            return blueList == null ? 0 : blueList.size();
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            Vh vh;
            if (convertView == null) {
                vh = new Vh();
                convertView = View.inflate(getBaseContext(), R.layout.item_searchblue_ly, null);
                vh.name = convertView.findViewById(R.id.item_searchblue_title);
                vh.address = convertView.findViewById(R.id.item_searchblue_address);
                vh.iv = convertView.findViewById(R.id.item_searchblue_iv);
                convertView.setTag(vh);

            } else {
                vh = (Vh) convertView.getTag();
            }


            vh.name.setText(blueList.get(position).getName());
            vh.address.setText("<" + blueList.get(position).getAddress() + ">");

            if (TextUtils.isEmpty(checkAddress)) {
                hideView(vh.iv);
            } else {
                if (TextUtils.equals(blueList.get(position).getAddress(), checkAddress)) {
                    displayView(vh.iv);
                } else {
                    hideView(vh.iv);
                }

            }
            return convertView;
        }


        class Vh {
            TextView name;
            TextView address;
            ImageView iv;
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mBlueScan != null) {
            mBlueScan.realse();
            mBlueScan = null;
        }
    }



    private void hideView(View view) {
        if (view != null) view.setVisibility(View.INVISIBLE);
    }

    private void displayView(View view) {
        if (view != null) view.setVisibility(View.VISIBLE);
    }


}
